Index: trunk/taginfoextract.groovy
===================================================================
--- trunk/taginfoextract.groovy	(revision 7554)
+++ trunk/taginfoextract.groovy	(revision 7625)
@@ -7,35 +7,30 @@
  * groovy -cp dist/josm-custom.jar taginfoextract.groovy
  */
-
-import java.io.BufferedReader
 import java.awt.image.BufferedImage
+
 import javax.imageio.ImageIO
 
 import org.openstreetmap.josm.Main
+import org.openstreetmap.josm.data.Version
 import org.openstreetmap.josm.data.coor.LatLon
 import org.openstreetmap.josm.data.osm.Node
 import org.openstreetmap.josm.data.osm.Way
+import org.openstreetmap.josm.data.osm.visitor.paint.MapPaintSettings
+import org.openstreetmap.josm.data.osm.visitor.paint.StyledMapRenderer
 import org.openstreetmap.josm.data.projection.Projections
-import org.openstreetmap.josm.data.Version
+import org.openstreetmap.josm.gui.NavigatableComponent
 import org.openstreetmap.josm.gui.mappaint.AreaElemStyle
-import org.openstreetmap.josm.gui.mappaint.Cascade
 import org.openstreetmap.josm.gui.mappaint.Environment
 import org.openstreetmap.josm.gui.mappaint.LineElemStyle
+import org.openstreetmap.josm.gui.mappaint.MultiCascade
+import org.openstreetmap.josm.gui.mappaint.MapPaintStyles.IconReference
+import org.openstreetmap.josm.gui.mappaint.mapcss.MapCSSStyleSource
 import org.openstreetmap.josm.gui.mappaint.mapcss.Condition.SimpleKeyValueCondition
-import org.openstreetmap.josm.gui.mappaint.mapcss.MapCSSStyleSource
+import org.openstreetmap.josm.gui.mappaint.mapcss.Selector.GeneralSelector
 import org.openstreetmap.josm.gui.mappaint.mapcss.parsergen.MapCSSParser
-import org.openstreetmap.josm.gui.mappaint.mapcss.Selector.GeneralSelector
-import org.openstreetmap.josm.gui.mappaint.MapPaintStyles.IconReference
-import org.openstreetmap.josm.gui.mappaint.MultiCascade
 import org.openstreetmap.josm.io.CachedFile
 
-import org.openstreetmap.josm.gui.NavigatableComponent
-import org.openstreetmap.josm.data.osm.visitor.paint.StyledMapRenderer
-import org.openstreetmap.josm.data.Bounds
-//import org.openstreetmap.josm.data.osm.DataSet
-import org.openstreetmap.josm.data.osm.visitor.paint.MapPaintSettings
-
 class taginfoextract {
-    
+
     static def options
     static String image_dir
@@ -46,5 +41,5 @@
     def base_dir = "."
     def tags = [] as Set
-    
+
     private def cached_svnrev
 
@@ -53,16 +48,16 @@
      */
     abstract class Checker {
-        
+
         def tag
         def osm
-        
+
         Checker(tag) {
             this.tag = tag
         }
-        
+
         def apply_stylesheet(osm) {
             osm.put(tag[0], tag[1])
             def mc = new MultiCascade()
-            
+
             def env = new Environment(osm, mc, null, style_source)
             for (def r in style_source.rules) {
@@ -80,5 +75,5 @@
             return env
         }
-        
+
         /**
          * Determine full image url (can refer to JOSM or OSM repository).
@@ -100,5 +95,5 @@
          * Create image file from ElemStyle.
          * @return the URL
-         */        
+         */
         def create_image(elem_style, type, nc) {
             def img = new BufferedImage(16, 16, BufferedImage.TYPE_INT_ARGB)
@@ -107,5 +102,5 @@
             def renderer = new StyledMapRenderer(g, nc, false)
             renderer.getSettings(false)
-            elem_style.paintPrimitive(osm, MapPaintSettings.INSTANCE, renderer, false, false)
+            elem_style.paintPrimitive(osm, MapPaintSettings.INSTANCE, renderer, false, false, false)
             def base_url = options.imgurlprefix ? options.imgurlprefix : image_dir
             def image_name = "${type}_${tag[0]}=${tag[1]}.png"
@@ -234,5 +229,5 @@
         }
     }
-    
+
     void run() {
         init()
@@ -280,5 +275,5 @@
                 }
             }
-            
+
             output """${sep}    {
                      |      "key": "${tag[0]}",
@@ -294,5 +289,5 @@
             }
             sep = ",\n"
-        }    
+        }
         output """
         |  ]
@@ -343,5 +338,5 @@
             xml = "svn info --xml ${base_dir}/images/styles/standard/".execute().text
         }
-        
+
         def svninfo = new XmlParser().parseText(xml)
         def rev = svninfo.entry.'@revision'[0]
@@ -350,5 +345,5 @@
         return cached_svnrev
     }
-    
+
     /**
      * Read the style sheet file and parse the MapCSS code.
@@ -362,5 +357,5 @@
         parser.sheet(style_source)
     }
-    
+
     /**
      * Collect all the tag from the style sheet.
@@ -382,5 +377,5 @@
     /**
      * Write the JSON output (either to file or to command line).
-     */    
+     */
     def output(x) {
         if (output_file != null) {
@@ -398,5 +393,5 @@
         System.err.print(s);
     }
-    
+
 }
 