Index: /trunk/data/defaultpresets.xml
===================================================================
--- /trunk/data/defaultpresets.xml	(revision 7710)
+++ /trunk/data/defaultpresets.xml	(revision 7711)
@@ -6987,5 +6987,5 @@
             </optional>
         </item> <!-- Tree Row -->
-        <item name="Wood" icon="presets/landuse.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Wood" icon="presets/landuse.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:natural=wood"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:natural=wood"
@@ -7000,5 +7000,5 @@
             <reference ref="leaf" />
         </item> <!-- Wood -->
-        <item name="Forest" icon="presets/landuse.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Forest" icon="styles/standard/misc/landmark/trees.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=forest"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=forest"
@@ -7127,5 +7127,5 @@
     </group> <!-- Nature -->
     <group name="Land use" icon="presets/landuse.png">
-        <item name="Farmyard" icon="presets/landuse.png" type="closedway,relation" preset_name_label="true">
+        <item name="Farmyard" icon="styles/standard/misc/landuse/farmyard.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=farmyard"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=farmyard"
@@ -7150,5 +7150,5 @@
             <text key="name" text="Name" />
         </item> <!-- Farmland -->
-        <item name="Meadow" icon="presets/landuse.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Meadow" icon="styles/standard/misc/landuse/meadow.svg" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=meadow"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=meadow"
@@ -7172,5 +7172,5 @@
             <text key="name" text="Name" />
         </item> <!-- Orchard -->
-        <item name="Vineyard" icon="presets/fruits.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Vineyard" icon="presets/fruits.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=vineyard"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=vineyard"
@@ -7206,5 +7206,5 @@
             <text key="species" text="Species" />
         </item> <!-- Plant Nursery -->
-        <item name="Allotments" icon="presets/landuse.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Allotments" icon="styles/standard/misc/landuse/allotments.svg" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=allotments"
                   cs.href="http://wiki.openstreetmap.org/wiki/Cs:Tag:landuse=allotments"
@@ -7221,5 +7221,5 @@
         </item> <!-- Allotments -->
         <separator/>
-        <item name="Garden" icon="presets/empty.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Garden" icon="styles/standard/leisure/garden.png" type="node,closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:leisure=garden"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:leisure=garden"
@@ -7231,5 +7231,5 @@
             <text key="name" text="Name" />
         </item> <!-- Garden -->
-        <item name="Grass" icon="presets/landuse.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Grass" icon="styles/standard/misc/landuse/meadow.svg" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=grass"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=grass"
@@ -7244,5 +7244,5 @@
             <text key="name" text="Name" />
         </item> <!-- Grass -->
-        <item name="Village Green" icon="presets/landuse.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Village Green" icon="styles/standard/leisure/common.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=village_green"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=village_green"
@@ -7256,5 +7256,5 @@
             <text key="name" text="Name" />
         </item> <!-- Village Green -->
-        <item name="Common" icon="presets/empty.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Common" icon="styles/standard/leisure/common.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:leisure=common"
                   pt_BR.href="http://wiki.openstreetmap.org/wiki/Pt-br:Tag:leisure=common"
@@ -7264,5 +7264,5 @@
             <text key="name" text="Name" />
         </item> <!-- Common -->
-        <item name="Park" icon="presets/empty.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Park" icon="styles/standard/leisure/park.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:leisure=park"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:leisure=park"
@@ -7277,5 +7277,5 @@
             <text key="name" text="Name" />
         </item> <!-- Park -->
-        <item name="Recreation Ground" icon="presets/landuse.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Recreation Ground" icon="styles/standard/leisure/common.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=recreation_ground"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=recreation_ground"
@@ -7315,5 +7315,5 @@
             <reference ref="religious" />
         </item> <!-- Graveyard -->
-        <item name="Cemetery" icon="presets/cemetery.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Cemetery" icon="presets/cemetery.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=cemetery"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=cemetery"
@@ -7330,5 +7330,5 @@
             <reference ref="religious" />
         </item> <!-- Cemetery -->
-        <item name="Religious" icon="styles/standard/religion.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Religious" icon="styles/standard/religion.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=religious"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=religious"
@@ -7339,5 +7339,5 @@
             <reference ref="religious" />
         </item> <!-- Religious -->
-        <item name="Retail" icon="styles/standard/shop/supermarket.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Retail" icon="styles/standard/shop/mall.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=retail"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=retail"
@@ -7350,5 +7350,5 @@
             <text key="name" text="Name" />
         </item> <!-- Retail -->
-        <item name="Commercial" icon="presets/empty.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Commercial" icon="styles/standard/misc/landuse/commercial.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=commercial"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=commercial"
@@ -7361,5 +7361,5 @@
             <text key="name" text="Name" />
         </item> <!-- Commercial -->
-        <item name="Industrial" icon="presets/works.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Industrial" icon="styles/standard/misc/landmark/works.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=industrial"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=industrial"
@@ -7373,5 +7373,5 @@
             <text key="name" text="Name" />
         </item> <!-- Industrial -->
-        <item name="Garages" icon="presets/garages.png" type="closedway" preset_name_label="true">
+        <item name="Garages" icon="presets/garages.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=garages"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=garages"
@@ -7396,5 +7396,5 @@
             <text key="name" text="Name" />
         </item> <!-- Railway Land -->
-        <item name="Military" icon="presets/military.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Military" icon="presets/military.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=military"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=military"
@@ -7407,5 +7407,5 @@
         </item> <!-- Military -->
         <separator/>
-        <item name="Construction Area" icon="presets/construction.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Construction Area" icon="presets/construction.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=construction"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=construction"
@@ -7419,5 +7419,5 @@
             <text key="name" text="Name" />
         </item> <!-- Construction Area -->
-        <item name="Brownfield" icon="presets/landuse.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Brownfield" icon="presets/landuse.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=brownfield"
                   cs.href="http://wiki.openstreetmap.org/wiki/Cs:Tag:landuse=brownfield"
@@ -7430,5 +7430,5 @@
             <text key="name" text="Name" />
         </item> <!-- Brownfield -->
-        <item name="Greenfield" icon="presets/landuse.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Greenfield" icon="presets/landuse.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=greenfield"
                   cs.href="http://wiki.openstreetmap.org/wiki/Cs:Tag:landuse=greenfield"
@@ -7440,5 +7440,5 @@
             <text key="name" text="Name" />
         </item> <!-- Greenfield -->
-        <item name="Landfill" icon="presets/landuse.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Landfill" icon="presets/landuse.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=landfill"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=landfill"
@@ -7451,5 +7451,5 @@
             <text key="name" text="Name" />
         </item> <!-- Landfill -->
-        <item name="Quarry" icon="presets/mine.png" type="node,closedway,relation" preset_name_label="true">
+        <item name="Quarry" icon="presets/mine.png" type="closedway,relation" preset_name_label="true">
             <link href="http://wiki.openstreetmap.org/wiki/Tag:landuse=quarry"
                   de.href="http://wiki.openstreetmap.org/wiki/DE:Tag:landuse=quarry"
Index: /trunk/styles/standard/elemstyles.mapcss
===================================================================
--- /trunk/styles/standard/elemstyles.mapcss	(revision 7710)
+++ /trunk/styles/standard/elemstyles.mapcss	(revision 7711)
@@ -1393,5 +1393,5 @@
 }
 node[leisure=park] {
-    icon-image: "leisure/park.png";
+    icon-image: "misc/deprecated.png";
     set icon_z17;
     text: auto;
@@ -2807,39 +2807,9 @@
     fill-color: green#b1e0c2;
 }
-node[landuse=farm] {
-    icon-image: "misc/landmark/farm.png";
-    set icon_z17;
-    text: auto;
-}
-node[landuse=farmland] {
-    icon-image: "misc/landuse/farmland.png";
-    set icon_z17;
-    text: auto;
-}
-node[landuse=meadow] {
-    icon-image: "misc/no_icon.png";
-    set icon_z17;
-    text: auto;
-}
-node[landuse=vineyard] {
-    icon-image: "shop/groceries/fruits.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=quarry] {
     fill-color: quarry#888888;
 }
-node[landuse=quarry] {
-    icon-image: "misc/landmark/mine.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=landfill] {
     fill-color: landfill#663300;
-}
-node[landuse=landfill] {
-    icon-image: "misc/no_icon.png";
-    set icon_z17;
-    text: auto;
 }
 area[landuse=basin],
@@ -2847,17 +2817,6 @@
     fill-color: basin#0000bf;
 }
-node[landuse=basin],
-node[landuse=reservoir] {
-    icon-image: "misc/no_icon.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=forest] {
     fill-color: forest#b1efc8;
-}
-node[landuse=forest] {
-    icon-image: "misc/landmark/trees.png";
-    set icon_z17;
-    text: auto;
 }
 area[landuse=allotments],
@@ -2867,43 +2826,12 @@
     fill-color: green#b1e0c2;
 }
-node[landuse=allotments] {
-    icon-image: "misc/landmark/plant.png";
-    set icon_z17;
-    text: auto;
-}
-node[landuse=greenhouse_horticulture] {
-    icon-image: "misc/landuse/greenhouse_horticulture.png";
-    set icon_z17;
-    text: auto;
-}
-node[landuse=plant_nursery],
-node[landuse=grass] {
-    icon-image: "misc/landmark/plant.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=residential] {
     fill-color: residential#f0f0f0;
 }
-node[landuse=residential] {
-    icon-image: "misc/landuse/residential.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=garages] {
     fill-color: garages#d6c8aa;
 }
-node[landuse=garages] {
-    icon-image: "misc/landuse/garages.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=farmyard] {
     fill-color: farmyard#f0f0f0;
-}
-node[landuse=farmyard] {
-    icon-image: "misc/no_icon.png";
-    set icon_z17;
-    text: auto;
 }
 area[landuse=retail],
@@ -2911,45 +2839,15 @@
     fill-color: retail#ffc4ee;
 }
-node[landuse=retail] {
-    icon-image: "shop/mall.png";
-    set icon_z17;
-    text: auto;
-}
-node[landuse=commercial] {
-    icon-image: "misc/landuse/commercial.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=industrial] {
     fill-color: industrial#ecd8ff;
 }
-node[landuse=industrial] {
-    icon-image: "misc/landmark/works.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=brownfield] {
     fill-color: brownfield#ecba32;
 }
-node[landuse=brownfield] {
-    icon-image: "misc/no_icon.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=greenfield] {
     fill-color: greenfield#b1ec5c;
 }
-node[landuse=greenfield] {
-    icon-image: "misc/no_icon.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=railway] {
     fill-color: railland#888888;
-}
-node[landuse=railway] {
-    icon-image: "transport/railway_station.png";
-    set icon_z17;
-    text: auto;
 }
 area[landuse=construction] {
@@ -2961,17 +2859,7 @@
     dashes: 9,9;
 }
-node[landuse=construction] {
-    icon-image: "misc/construction.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=military] {
     fill-color: military#b62c2c;
 }
-node[landuse=military] {
-    icon-image: "vehicle/tank.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=religious] {
     fill-color: religious#ffd454;
@@ -2980,22 +2868,12 @@
     fill-color: cemetery#b1efc8;
 }
-node[landuse=cemetery] {
-    icon-image: "rendering/landuse/cemetery.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=village_green] {
     fill-color: green#b1e0c2;
 }
-node[landuse=village_green] {
-    icon-image: "leisure/common.png";
-    set icon_z17;
-    text: auto;
-}
 area[landuse=recreation_ground] {
     fill-color: green#b1e0c2;
 }
-node[landuse=recreation_ground] {
-    icon-image: "leisure/common.png";
+node[landuse] {
+    icon-image: "misc/deprecated.png";
     set icon_z17;
     text: auto;
@@ -3871,5 +3749,5 @@
 }
 node[natural=grassland] {
-    icon-image: "misc/no_icon.png";
+    icon-image: "misc/deprecated.png";
     set icon_z17;
     text: auto;