Index: trunk/images_nodist/mapmode/parallel.svg
===================================================================
--- trunk/images_nodist/mapmode/parallel.svg	(revision 7977)
+++ trunk/images_nodist/mapmode/parallel.svg	(revision 8031)
@@ -14,5 +14,5 @@
    id="svg2"
    version="1.1"
-   inkscape:version="0.48.1 r9760"
+   inkscape:version="0.48.4 r9939"
    sodipodi:docname="parallel.svg"
    inkscape:export-xdpi="90"
@@ -90,14 +90,14 @@
      inkscape:pageopacity="0.0"
      inkscape:pageshadow="2"
-     inkscape:zoom="26.875628"
-     inkscape:cx="5.3507958"
-     inkscape:cy="11.47364"
+     inkscape:zoom="13.437814"
+     inkscape:cx="5.2811711"
+     inkscape:cy="9.8423034"
      inkscape:document-units="px"
      inkscape:current-layer="layer1"
      showgrid="true"
-     inkscape:window-width="1438"
-     inkscape:window-height="861"
+     inkscape:window-width="1366"
+     inkscape:window-height="768"
      inkscape:window-x="0"
-     inkscape:window-y="0"
+     inkscape:window-y="25"
      inkscape:window-maximized="0">
     <inkscape:grid
@@ -117,5 +117,5 @@
         <dc:type
            rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
-        <dc:title />
+        <dc:title></dc:title>
       </cc:Work>
     </rdf:RDF>
@@ -128,53 +128,55 @@
     <path
        style="fill:none;stroke:#000000;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-       d="m 21.000002,1036.3622 -6,6 0,7"
+       d="m 19.999715,1036.3622 -6,6 0,7"
        id="path2906"
-       sodipodi:nodetypes="ccc" />
+       sodipodi:nodetypes="ccc"
+       inkscape:connector-curvature="0" />
     <path
        style="fill:none;stroke:#000000;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-       d="m 16.000002,1031.3622 -9.0000017,10 0,8"
+       d="m 14.999715,1031.3622 -9.0000013,10 0,8"
        id="path2904"
-       sodipodi:nodetypes="ccc" />
+       sodipodi:nodetypes="ccc"
+       inkscape:connector-curvature="0" />
     <rect
-       style="fill:#ffffff;fill-opacity:1;stroke:#ff0000;stroke-width:1.00036621;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none"
+       style="fill:#ffffff;fill-opacity:1;stroke:#df421e;stroke-width:1.00036621;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none"
        id="rect2826-54-4-52"
        width="2.9996338"
        height="2.9996338"
-       x="13.50047"
+       x="12.500183"
        y="1047.8492" />
     <rect
-       style="fill:#ffffff;fill-opacity:1;stroke:#ff0000;stroke-width:1.00036621;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none"
+       style="fill:#ffffff;fill-opacity:1;stroke:#df421e;stroke-width:1.00036621;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none"
        id="rect2826-54-4-4"
        width="2.9996338"
        height="2.9996338"
-       x="13.50047"
+       x="12.500183"
        y="1040.8492" />
     <rect
-       style="fill:#ffffff;fill-opacity:1;stroke:#ff0000;stroke-width:1.00036621;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none"
+       style="fill:#ffffff;fill-opacity:1;stroke:#df421e;stroke-width:1.00036621;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none"
        id="rect2826-54-4-7"
        width="2.9996338"
        height="2.9996338"
-       x="19.500469"
+       x="18.500183"
        y="1034.8492" />
     <rect
-       style="fill:#ffffff;fill-opacity:1;stroke:#ff0000;stroke-width:1.00036621;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none"
+       style="fill:#ffffff;fill-opacity:1;stroke:#df421e;stroke-width:1.00036621;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none"
        id="rect2826-54-4-5"
        width="2.9996338"
        height="2.9996338"
-       x="14.50047"
+       x="13.500183"
        y="1029.8492" />
     <rect
-       style="fill:#ffffff;fill-opacity:1;stroke:#ff0000;stroke-width:1.00036621;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none"
+       style="fill:#ffffff;fill-opacity:1;stroke:#df421e;stroke-width:1.00036621;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none"
        id="rect2826-54-4"
        width="2.9996338"
        height="2.9996338"
-       x="5.5004697"
+       x="4.5001831"
        y="1039.8492" />
     <rect
-       style="fill:#ffffff;fill-opacity:1;stroke:#ff0000;stroke-width:1.00036621;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none"
+       style="fill:#ffffff;fill-opacity:1;stroke:#df421e;stroke-width:1.00036621;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none"
        id="rect2826-54-4-54"
        width="2.9996338"
        height="2.9996338"
-       x="5.5004697"
+       x="4.5001831"
        y="1047.8492" />
   </g>