Index: trunk/src/org/openstreetmap/josm/io/MessageNotifier.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/MessageNotifier.java	(revision 8118)
+++ trunk/src/org/openstreetmap/josm/io/MessageNotifier.java	(revision 8126)
@@ -50,5 +50,5 @@
     private static final Runnable WORKER = new Worker();
 
-    private static ScheduledFuture<?> task = null;
+    private static volatile ScheduledFuture<?> task = null;
 
     private static class Worker implements Runnable {
Index: trunk/src/org/openstreetmap/josm/io/OsmReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmReader.java	(revision 8118)
+++ trunk/src/org/openstreetmap/josm/io/OsmReader.java	(revision 8126)
@@ -55,5 +55,5 @@
 
     /** Used by plugins to register themselves as data postprocessors. */
-    private static List<OsmServerReadPostprocessor> postprocessors;
+    private static volatile List<OsmServerReadPostprocessor> postprocessors;
 
     /** register a new postprocessor */
Index: trunk/src/org/openstreetmap/josm/io/OsmServerWriter.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmServerWriter.java	(revision 8118)
+++ trunk/src/org/openstreetmap/josm/io/OsmServerWriter.java	(revision 8126)
@@ -37,5 +37,5 @@
     private Collection<OsmPrimitive> processed;
 
-    private static List<OsmServerWritePostprocessor> postprocessors;
+    private static volatile List<OsmServerWritePostprocessor> postprocessors;
     public static void registerPostprocessor(OsmServerWritePostprocessor pp) {
         if (postprocessors == null) {
Index: trunk/src/org/openstreetmap/josm/io/OsmWriterFactory.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmWriterFactory.java	(revision 8118)
+++ trunk/src/org/openstreetmap/josm/io/OsmWriterFactory.java	(revision 8126)
@@ -17,5 +17,5 @@
 public class OsmWriterFactory {
 
-    public static OsmWriterFactory theFactory;
+    public static volatile OsmWriterFactory theFactory;
     public static OsmWriter createOsmWriter(PrintWriter out, boolean osmConform, String version) {
         // pre-set factory with this default implementation; can still be overwritten
Index: trunk/src/org/openstreetmap/josm/io/auth/CredentialsManager.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/auth/CredentialsManager.java	(revision 8118)
+++ trunk/src/org/openstreetmap/josm/io/auth/CredentialsManager.java	(revision 8126)
@@ -20,5 +20,5 @@
 public class CredentialsManager implements CredentialsAgent {
 
-    private static CredentialsManager instance;
+    private static volatile CredentialsManager instance;
 
     /**
Index: trunk/src/org/openstreetmap/josm/io/auth/DefaultAuthenticator.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/auth/DefaultAuthenticator.java	(revision 8118)
+++ trunk/src/org/openstreetmap/josm/io/auth/DefaultAuthenticator.java	(revision 8126)
@@ -16,5 +16,5 @@
  */
 public final class DefaultAuthenticator extends Authenticator {
-    private static DefaultAuthenticator instance;
+    private static volatile DefaultAuthenticator instance;
 
     /**
Index: trunk/src/org/openstreetmap/josm/io/remotecontrol/RemoteControlHttpServer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/remotecontrol/RemoteControlHttpServer.java	(revision 8118)
+++ trunk/src/org/openstreetmap/josm/io/remotecontrol/RemoteControlHttpServer.java	(revision 8126)
@@ -23,5 +23,5 @@
     private ServerSocket server;
 
-    private static RemoteControlHttpServer instance;
+    private static volatile RemoteControlHttpServer instance;
 
     /**
Index: trunk/src/org/openstreetmap/josm/io/remotecontrol/RemoteControlHttpsServer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/remotecontrol/RemoteControlHttpsServer.java	(revision 8118)
+++ trunk/src/org/openstreetmap/josm/io/remotecontrol/RemoteControlHttpsServer.java	(revision 8126)
@@ -75,5 +75,5 @@
     private ServerSocket server;
 
-    private static RemoteControlHttpsServer instance;
+    private static volatile RemoteControlHttpsServer instance;
     private boolean initOK = false;
     private SSLContext sslContext;