Index: trunk/src/org/openstreetmap/josm/gui/history/CoordinateInfoViewer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/CoordinateInfoViewer.java	(revision 8304)
+++ trunk/src/org/openstreetmap/josm/gui/history/CoordinateInfoViewer.java	(revision 8308)
@@ -32,5 +32,5 @@
 
     /** the model */
-    private HistoryBrowserModel model;
+    private transient HistoryBrowserModel model;
     /** the common info panel for the history node in role REFERENCE_POINT_IN_TIME */
     private VersionInfoPanel referenceInfoPanel;
@@ -171,5 +171,5 @@
         private JLabel lblLat;
         private JLabel lblLon;
-        private HistoryBrowserModel model;
+        private transient HistoryBrowserModel model;
         private PointInTimeType role;
 
Index: trunk/src/org/openstreetmap/josm/gui/history/DiffTableModel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/DiffTableModel.java	(revision 8304)
+++ trunk/src/org/openstreetmap/josm/gui/history/DiffTableModel.java	(revision 8308)
@@ -1,6 +1,4 @@
 // License: GPL. For details, see LICENSE file.
 package org.openstreetmap.josm.gui.history;
-
-import static org.openstreetmap.josm.tools.I18n.tr;
 
 import java.util.ArrayList;
@@ -16,5 +14,5 @@
  */
 class DiffTableModel extends AbstractTableModel {
-    private List<TwoColumnDiff.Item> rows = new ArrayList<>();
+    private transient List<TwoColumnDiff.Item> rows = new ArrayList<>();
     private boolean reversed = false;
 
Index: trunk/src/org/openstreetmap/josm/gui/history/HistoryBrowser.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/HistoryBrowser.java	(revision 8304)
+++ trunk/src/org/openstreetmap/josm/gui/history/HistoryBrowser.java	(revision 8308)
@@ -24,5 +24,5 @@
 
     /** the model */
-    private HistoryBrowserModel model;
+    private transient HistoryBrowserModel model;
     private TagInfoViewer tagInfoViewer;
     private NodeListViewer nodeListViewer;
Index: trunk/src/org/openstreetmap/josm/gui/history/HistoryBrowserModel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/HistoryBrowserModel.java	(revision 8304)
+++ trunk/src/org/openstreetmap/josm/gui/history/HistoryBrowserModel.java	(revision 8308)
@@ -531,5 +531,5 @@
     public class TagTableModel extends AbstractTableModel {
 
-        private List<String> keys;
+        private transient List<String> keys;
         private PointInTimeType pointInTimeType;
 
Index: trunk/src/org/openstreetmap/josm/gui/history/HistoryViewerPanel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/HistoryViewerPanel.java	(revision 8304)
+++ trunk/src/org/openstreetmap/josm/gui/history/HistoryViewerPanel.java	(revision 8308)
@@ -17,10 +17,10 @@
  */
 public abstract class HistoryViewerPanel extends JPanel {
-    
-    protected HistoryBrowserModel model;
+
+    protected transient HistoryBrowserModel model;
     protected VersionInfoPanel referenceInfoPanel;
     protected VersionInfoPanel currentInfoPanel;
-    protected AdjustmentSynchronizer adjustmentSynchronizer;
-    protected SelectionSynchronizer selectionSynchronizer;
+    protected transient AdjustmentSynchronizer adjustmentSynchronizer;
+    protected transient SelectionSynchronizer selectionSynchronizer;
 
     protected HistoryViewerPanel(HistoryBrowserModel model) {
@@ -28,5 +28,5 @@
         build();
     }
-    
+
     private JScrollPane embedInScrollPane(JTable table) {
         JScrollPane pane = new JScrollPane(table);
@@ -34,5 +34,5 @@
         return pane;
     }
-    
+
     /**
      * Sets the history browsing model.
@@ -48,5 +48,5 @@
         }
     }
-    
+
     protected final void unregisterAsObserver(HistoryBrowserModel model) {
         if (currentInfoPanel != null) {
@@ -57,5 +57,5 @@
         }
     }
-    
+
     protected final void registerAsObserver(HistoryBrowserModel model) {
         if (currentInfoPanel != null) {
@@ -66,9 +66,9 @@
         }
     }
-    
+
     protected abstract JTable buildReferenceTable();
-    
+
     protected abstract JTable buildCurrentTable();
-    
+
     private void build() {
         setLayout(new GridBagLayout());
Index: trunk/src/org/openstreetmap/josm/gui/history/NodeListViewer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/NodeListViewer.java	(revision 8304)
+++ trunk/src/org/openstreetmap/josm/gui/history/NodeListViewer.java	(revision 8308)
@@ -48,9 +48,9 @@
 public class NodeListViewer extends JPanel {
 
-    private HistoryBrowserModel model;
+    private transient HistoryBrowserModel model;
     private VersionInfoPanel referenceInfoPanel;
     private VersionInfoPanel currentInfoPanel;
-    private AdjustmentSynchronizer adjustmentSynchronizer;
-    private SelectionSynchronizer selectionSynchronizer;
+    private transient AdjustmentSynchronizer adjustmentSynchronizer;
+    private transient SelectionSynchronizer selectionSynchronizer;
     private NodeListPopupMenu popupMenu;
 
@@ -215,6 +215,9 @@
 
     static class ZoomToNodeAction extends AbstractAction {
-        private PrimitiveId primitiveId;
-
+        private transient PrimitiveId primitiveId;
+
+        /**
+         * Constructs a new {@code ZoomToNodeAction}.
+         */
         public ZoomToNodeAction() {
             putValue(NAME, tr("Zoom to node"));
@@ -258,6 +261,9 @@
 
     static class ShowHistoryAction extends AbstractAction {
-        private PrimitiveId primitiveId;
-
+        private transient PrimitiveId primitiveId;
+
+        /**
+         * Constructs a new {@code ShowHistoryAction}.
+         */
         public ShowHistoryAction() {
             putValue(NAME, tr("Show history"));
Index: trunk/src/org/openstreetmap/josm/gui/history/RelationMemberListTableCellRenderer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/RelationMemberListTableCellRenderer.java	(revision 8304)
+++ trunk/src/org/openstreetmap/josm/gui/history/RelationMemberListTableCellRenderer.java	(revision 8308)
@@ -31,5 +31,5 @@
     public static final Color BGCOLOR_SELECTED = new Color(143,170,255);
 
-    private Map<OsmPrimitiveType, ImageIcon> icons;
+    private transient Map<OsmPrimitiveType, ImageIcon> icons;
 
     /**
Index: trunk/src/org/openstreetmap/josm/gui/history/VersionInfoPanel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/VersionInfoPanel.java	(revision 8304)
+++ trunk/src/org/openstreetmap/josm/gui/history/VersionInfoPanel.java	(revision 8308)
@@ -46,5 +46,5 @@
 public class VersionInfoPanel extends JPanel implements Observer{
     private PointInTimeType pointInTimeType;
-    private HistoryBrowserModel model;
+    private transient HistoryBrowserModel model;
     private JMultilineLabel lblInfo;
     private UrlLabel lblUser;
Index: trunk/src/org/openstreetmap/josm/gui/history/VersionTable.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/VersionTable.java	(revision 8304)
+++ trunk/src/org/openstreetmap/josm/gui/history/VersionTable.java	(revision 8308)
@@ -46,5 +46,5 @@
 public class VersionTable extends JTable implements Observer{
     private VersionTablePopupMenu popupMenu;
-    private final HistoryBrowserModel model;
+    private final transient HistoryBrowserModel model;
 
     protected void build() {
@@ -148,6 +148,9 @@
 
     static class ChangesetInfoAction extends AbstractInfoAction {
-        private HistoryOsmPrimitive primitive;
-
+        private transient HistoryOsmPrimitive primitive;
+
+        /**
+         * Constructs a new {@code ChangesetInfoAction}.
+         */
         public ChangesetInfoAction() {
             super(true);
@@ -178,6 +181,9 @@
 
     static class UserInfoAction extends AbstractInfoAction {
-        private HistoryOsmPrimitive primitive;
-
+        private transient HistoryOsmPrimitive primitive;
+
+        /**
+         * Constructs a new {@code UserInfoAction}.
+         */
         public UserInfoAction() {
             super(true);