Index: trunk/src/org/openstreetmap/josm/actions/OpenFileAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/OpenFileAction.java	(revision 8378)
+++ trunk/src/org/openstreetmap/josm/actions/OpenFileAction.java	(revision 8379)
@@ -157,6 +157,5 @@
         protected void alertFilesNotMatchingWithImporter(Collection<File> files, FileImporter importer) {
             final StringBuilder msg = new StringBuilder();
-            msg.append("<html>");
-            msg.append(
+            msg.append("<html>").append(
                     trn(
                             "Cannot open {0} file with the file importer ''{1}''.",
@@ -166,6 +165,5 @@
                             importer.filter.getDescription()
                     )
-            ).append("<br>");
-            msg.append("<ul>");
+            ).append("<br>").append("<ul>");
             for (File f: files) {
                 msg.append("<li>").append(f.getAbsolutePath()).append("</li>");
@@ -184,6 +182,5 @@
         protected void alertFilesWithUnknownImporter(Collection<File> files) {
             final StringBuilder msg = new StringBuilder();
-            msg.append("<html>");
-            msg.append(
+            msg.append("<html>").append(
                     trn(
                             "Cannot open {0} file because file does not exist or no suitable file importer is available.",
@@ -192,12 +189,9 @@
                             files.size()
                     )
-            ).append("<br>");
-            msg.append("<ul>");
+            ).append("<br>").append("<ul>");
             for (File f: files) {
-                msg.append("<li>");
-                msg.append(f.getAbsolutePath());
-                msg.append(" (<i>");
-                msg.append(f.exists() ? tr("no importer") : tr("does not exist"));
-                msg.append("</i>)</li>");
+                msg.append("<li>").append(f.getAbsolutePath()).append(" (<i>")
+                   .append(f.exists() ? tr("no importer") : tr("does not exist"))
+                   .append("</i>)</li>");
             }
             msg.append("</ul>");
Index: trunk/src/org/openstreetmap/josm/actions/SearchNotesDownloadAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/SearchNotesDownloadAction.java	(revision 8378)
+++ trunk/src/org/openstreetmap/josm/actions/SearchNotesDownloadAction.java	(revision 8379)
@@ -73,5 +73,4 @@
 
         performSearch(searchTerm);
-
     }
 
@@ -91,11 +90,11 @@
 
         StringBuilder sb = new StringBuilder();
-        sb.append(OsmApi.getOsmApi().getBaseUrl());
-        sb.append("notes/search?limit=");
-        sb.append(noteLimit);
-        sb.append("&closed=");
-        sb.append(closedLimit);
-        sb.append("&q=");
-        sb.append(Utils.encodeUrl(searchTerm));
+        sb.append(OsmApi.getOsmApi().getBaseUrl())
+            .append("notes/search?limit=")
+            .append(noteLimit)
+            .append("&closed=")
+            .append(closedLimit)
+            .append("&q=")
+            .append(Utils.encodeUrl(searchTerm));
 
         new DownloadNotesTask().loadUrl(false, sb.toString(), null);
Index: trunk/src/org/openstreetmap/josm/actions/ShowStatusReportAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/ShowStatusReportAction.java	(revision 8378)
+++ trunk/src/org/openstreetmap/josm/actions/ShowStatusReportAction.java	(revision 8379)
@@ -69,25 +69,26 @@
     public static String getReportHeader() {
         StringBuilder text = new StringBuilder();
-        text.append(Version.getInstance().getReleaseAttributes());
-        text.append("\n");
-        text.append("Identification: " + Version.getInstance().getAgentString());
-        text.append("\n");
-        text.append("Memory Usage: ");
-        text.append(Runtime.getRuntime().totalMemory()/1024/1024);
-        text.append(" MB / ");
-        text.append(Runtime.getRuntime().maxMemory()/1024/1024);
-        text.append(" MB (");
-        text.append(Runtime.getRuntime().freeMemory()/1024/1024);
-        text.append(" MB allocated, but free)");
-        text.append("\n");
-        text.append("Java version: " + System.getProperty("java.version") + ", " + System.getProperty("java.vendor") + ", " + System.getProperty("java.vm.name"));
-        text.append("\n");
+        text.append(Version.getInstance().getReleaseAttributes())
+            .append("\n")
+            .append("Identification: ").append(Version.getInstance().getAgentString())
+            .append("\n")
+            .append("Memory Usage: ")
+            .append(Runtime.getRuntime().totalMemory()/1024/1024)
+            .append(" MB / ")
+            .append(Runtime.getRuntime().maxMemory()/1024/1024)
+            .append(" MB (")
+            .append(Runtime.getRuntime().freeMemory()/1024/1024)
+            .append(" MB allocated, but free)")
+            .append("\n")
+            .append("Java version: ").append(System.getProperty("java.version")).append(", ")
+            .append(System.getProperty("java.vendor")).append(", ").append(System.getProperty("java.vm.name"))
+            .append("\n");
         if (Main.platform.getClass() == PlatformHookUnixoid.class) {
             // Add Java package details
             String packageDetails = ((PlatformHookUnixoid) Main.platform).getJavaPackageDetails();
             if (packageDetails != null) {
-                text.append("Java package: ");
-                text.append(packageDetails);
-                text.append("\n");
+                text.append("Java package: ")
+                    .append(packageDetails)
+                    .append("\n");
             }
             // Add WebStart package details if run from JNLP
@@ -95,7 +96,7 @@
                 String webStartDetails = ((PlatformHookUnixoid) Main.platform).getWebStartPackageDetails();
                 if (webStartDetails != null) {
-                    text.append("WebStart package: ");
-                    text.append(webStartDetails);
-                    text.append("\n");
+                    text.append("WebStart package: ")
+                        .append(webStartDetails)
+                        .append("\n");
                 }
             }
@@ -148,7 +149,7 @@
             }
         }
-        text.append("\n");
-        text.append(PluginHandler.getBugReportText());
-        text.append("\n");
+        text.append("\n")
+            .append(PluginHandler.getBugReportText())
+            .append("\n");
 
         Collection<String> errorsWarnings = Main.getLastErrorAndWarnings();
Index: trunk/src/org/openstreetmap/josm/actions/downloadtasks/AbstractDownloadTask.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/downloadtasks/AbstractDownloadTask.java	(revision 8378)
+++ trunk/src/org/openstreetmap/josm/actions/downloadtasks/AbstractDownloadTask.java	(revision 8379)
@@ -4,4 +4,5 @@
 import java.util.ArrayList;
 import java.util.List;
+
 import org.openstreetmap.josm.io.XmlWriter;
 
@@ -50,19 +51,19 @@
     @Override
     public String acceptsDocumentationSummary() {
-        StringBuilder buf = new StringBuilder("<tr><td>");
-        buf.append(getTitle());
-        buf.append(":</td><td>");
+        StringBuilder buff = new StringBuilder("<tr><td>");
+        buff.append(getTitle())
+            .append(":</td><td>");
         String[] patterns = getPatterns();
         if (patterns.length>0) {
-            buf.append("<ul>");
+            buff.append("<ul>");
             for (String pattern: patterns) {
-                buf.append("<li>");
-                buf.append(XmlWriter.encode(pattern));
-                buf.append("</li>");
+                buff.append("<li>")
+                    .append(XmlWriter.encode(pattern))
+                    .append("</li>");
             }
-            buf.append("</ul>");
+            buff.append("</ul>");
         }
-        buf.append("</td></tr>");
-        return buf.toString();
+        buff.append("</td></tr>");
+        return buff.toString();
     }
 
@@ -80,13 +81,13 @@
     /**
      * Check / decide if the task is safe for remotecontrol.
-     * 
+     *
      * Keep in mind that a potential attacker has full control over the content
      * of the file that will be downloaded.
      * If it is possible to run arbitrary code or write to the local file
      * system, then the task is (obviously) not save for remote execution.
-     * 
+     *
      * The default value is false = unsafe. Override in a subclass to
      * allow running the task via remotecontol.
-     * 
+     *
      * @return true if it is safe to download and open any file of the
      * corresponding format, false otherwise
Index: trunk/src/org/openstreetmap/josm/actions/search/SearchAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/search/SearchAction.java	(revision 8378)
+++ trunk/src/org/openstreetmap/josm/actions/search/SearchAction.java	(revision 8379)
@@ -678,6 +678,6 @@
                 result.append('A');
             }
-            result.append(' ');
-            result.append(text);
+            result.append(' ')
+                  .append(text);
             return result.toString();
         }
Index: trunk/src/org/openstreetmap/josm/actions/upload/CyclicUploadDependencyException.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/upload/CyclicUploadDependencyException.java	(revision 8378)
+++ trunk/src/org/openstreetmap/josm/actions/upload/CyclicUploadDependencyException.java	(revision 8379)
@@ -32,6 +32,6 @@
     public String getMessage() {
         StringBuilder sb = new StringBuilder();
-        sb.append(tr("Cyclic dependency between relations:"));
-        sb.append("[");
+        sb.append(tr("Cyclic dependency between relations:"))
+          .append("[");
         for (int i=0; i< cycle.size(); i++) {
             if (i >0 ) {