Index: trunk/src/org/openstreetmap/josm/tools/PlatformHookUnixoid.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/PlatformHookUnixoid.java	(revision 8387)
+++ trunk/src/org/openstreetmap/josm/tools/PlatformHookUnixoid.java	(revision 8390)
@@ -526,5 +526,5 @@
                     w.append(key + "=" + value + "\n");
                 }
-                w.append("\n");
+                w.append('\n');
                 for (FontEntry entry: extras) {
                     if ("".equals(entry.name) || "".equals(entry.file)) {
@@ -539,5 +539,5 @@
                     w.append(key + "=" + value + "\n");
                 }
-                w.append("\n");
+                w.append('\n');
                 String fallback = props.getProperty("sequence.fallback");
                 if (fallback != null) {
Index: trunk/src/org/openstreetmap/josm/tools/Utils.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/Utils.java	(revision 8387)
+++ trunk/src/org/openstreetmap/josm/tools/Utils.java	(revision 8390)
@@ -931,5 +931,5 @@
                     all = new StringBuilder(line);
                 } else {
-                    all.append("\n");
+                    all.append('\n');
                     all.append(line);
                 }
@@ -1007,8 +1007,8 @@
                 ++cnt;
             } else if (cnt == 0) {
-                sb.append(",").append(cur);
+                sb.append(',').append(cur);
             } else {
-                sb.append("-").append(last);
-                sb.append(",").append(cur);
+                sb.append('-').append(last);
+                sb.append(',').append(cur);
                 cnt = 0;
             }
@@ -1016,5 +1016,5 @@
         }
         if (cnt >= 1) {
-            sb.append("-").append(last);
+            sb.append('-').append(last);
         }
         return sb.toString();
Index: trunk/src/org/openstreetmap/josm/tools/WikiReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/WikiReader.java	(revision 8387)
+++ trunk/src/org/openstreetmap/josm/tools/WikiReader.java	(revision 8390)
@@ -110,5 +110,5 @@
         for (String line = in.readLine(); line != null; line = in.readLine()) {
             if (!line.contains("[[TranslatedPages]]")) {
-                b.append(line.replaceAll(" />", ">")).append("\n");
+                b.append(line.replaceAll(" />", ">")).append('\n');
             }
         }
Index: trunk/src/org/openstreetmap/josm/tools/WindowGeometry.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/WindowGeometry.java	(revision 8387)
+++ trunk/src/org/openstreetmap/josm/tools/WindowGeometry.java	(revision 8390)
@@ -253,8 +253,6 @@
     public void remember(String preferenceKey) {
         StringBuilder value = new StringBuilder();
-        value.append("x=").append(topLeft.x).append(",")
-        .append("y=").append(topLeft.y).append(",")
-        .append("width=").append(extent.width).append(",")
-        .append("height=").append(extent.height);
+        value.append("x=").append(topLeft.x).append(",y=").append(topLeft.y)
+             .append(",width=").append(extent.width).append(",height=").append(extent.height);
         Main.pref.put(preferenceKey, value.toString());
     }
Index: trunk/src/org/openstreetmap/josm/tools/XmlObjectParser.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/XmlObjectParser.java	(revision 8387)
+++ trunk/src/org/openstreetmap/josm/tools/XmlObjectParser.java	(revision 8390)
@@ -125,7 +125,7 @@
                 return parseBoolean(value);
             else if (klass == Integer.TYPE || klass == Long.TYPE)
-                return Long.parseLong(value);
+                return Long.valueOf(value);
             else if (klass == Float.TYPE || klass == Double.TYPE)
-                return Double.parseDouble(value);
+                return Double.valueOf(value);
             return value;
         }
Index: trunk/src/org/openstreetmap/josm/tools/template_engine/Condition.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/template_engine/Condition.java	(revision 8387)
+++ trunk/src/org/openstreetmap/josm/tools/template_engine/Condition.java	(revision 8390)
@@ -47,9 +47,7 @@
                 sb.append(entry);
             } else {
-                sb.append("'");
-                sb.append(entry);
-                sb.append("'");
+                sb.append('\'').append(entry).append('\'');
             }
-            sb.append("|");
+            sb.append('|');
         }
         return sb.toString();
Index: trunk/src/org/openstreetmap/josm/tools/template_engine/Variable.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/template_engine/Variable.java	(revision 8387)
+++ trunk/src/org/openstreetmap/josm/tools/template_engine/Variable.java	(revision 8390)
@@ -35,5 +35,5 @@
                     first = false;
                 }
-                result.append(key).append("=").append(dataProvider.getTemplateValue(key, false));
+                result.append(key).append('=').append(dataProvider.getTemplateValue(key, false));
             }
         } else {