Index: trunk/src/org/openstreetmap/josm/tools/AudioPlayer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/AudioPlayer.java	(revision 8394)
+++ trunk/src/org/openstreetmap/josm/tools/AudioPlayer.java	(revision 8395)
@@ -277,6 +277,5 @@
                             if (playingUrl != command.url() ||
                                     stateChange != State.PAUSED ||
-                                    offset != 0)
-                            {
+                                    offset != 0) {
                                 if (audioInputStream != null) {
                                     Utils.close(audioInputStream);
Index: trunk/src/org/openstreetmap/josm/tools/Diff.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/Diff.java	(revision 8394)
+++ trunk/src/org/openstreetmap/josm/tools/Diff.java	(revision 8395)
@@ -170,6 +170,5 @@
         bd[bdiagoff + bmid] = xlim;
 
-        for (int c = 1;; ++c)
-        {
+        for (int c = 1;; ++c) {
             int d;          /* Active diagonal. */
             boolean big_snake = false;
@@ -186,6 +185,5 @@
                 --fmax;
             }
-            for (d = fmax; d >= fmin; d -= 2)
-            {
+            for (d = fmax; d >= fmin; d -= 2) {
                 int x, y, oldx, tlo = fd[fdiagoff + d - 1], thi = fd[fdiagoff + d + 1];
 
@@ -204,6 +202,5 @@
                 }
                 fd[fdiagoff + d] = x;
-                if (odd && bmin <= d && d <= bmax && bd[bdiagoff + d] <= fd[fdiagoff + d])
-                {
+                if (odd && bmin <= d && d <= bmax && bd[bdiagoff + d] <= fd[fdiagoff + d]) {
                     cost = 2 * c - 1;
                     return d;
@@ -222,6 +219,5 @@
                 --bmax;
             }
-            for (d = bmax; d >= bmin; d -= 2)
-            {
+            for (d = bmax; d >= bmin; d -= 2) {
                 int x, y, oldx, tlo = bd[bdiagoff + d - 1], thi = bd[bdiagoff + d + 1];
 
@@ -240,6 +236,5 @@
                 }
                 bd[bdiagoff + d] = x;
-                if (!odd && fmin <= d && d <= fmax && bd[bdiagoff + d] <= fd[fdiagoff + d])
-                {
+                if (!odd && fmin <= d && d <= fmax && bd[bdiagoff + d] <= fd[fdiagoff + d]) {
                     cost = 2 * c;
                     return d;
@@ -255,21 +250,17 @@
        of changes, the algorithm is linear in the file size.  */
 
-            if (c > 200 && big_snake && heuristic)
-            {
+            if (c > 200 && big_snake && heuristic) {
                 int best = 0;
                 int bestpos = -1;
 
-                for (d = fmax; d >= fmin; d -= 2)
-                {
+                for (d = fmax; d >= fmin; d -= 2) {
                     int dd = d - fmid;
                     int x = fd[fdiagoff + d];
                     int y = x - d;
                     int v = (x - xoff) * 2 - dd;
-                    if (v > 12 * (c + (dd < 0 ? -dd : dd)))
-                    {
+                    if (v > 12 * (c + (dd < 0 ? -dd : dd))) {
                         if (v > best
                                 && xoff + SNAKE_LIMIT <= x && x < xlim
-                                && yoff + SNAKE_LIMIT <= y && y < ylim)
-                        {
+                                && yoff + SNAKE_LIMIT <= y && y < ylim) {
                             /* We have a good enough best diagonal.
                                now insist that it end with a significant snake.  */
@@ -277,6 +268,5 @@
 
                             for (k = 1; xvec[x - k] == yvec[y - k]; k++)
-                                if (k == SNAKE_LIMIT)
-                                {
+                                if (k == SNAKE_LIMIT) {
                                     best = v;
                                     bestpos = d;
@@ -286,6 +276,5 @@
                     }
                 }
-                if (best > 0)
-                {
+                if (best > 0) {
                     cost = 2 * c - 1;
                     return bestpos;
@@ -293,16 +282,13 @@
 
                 best = 0;
-                for (d = bmax; d >= bmin; d -= 2)
-                {
+                for (d = bmax; d >= bmin; d -= 2) {
                     int dd = d - bmid;
                     int x = bd[bdiagoff + d];
                     int y = x - d;
                     int v = (xlim - x) * 2 + dd;
-                    if (v > 12 * (c + (dd < 0 ? -dd : dd)))
-                    {
+                    if (v > 12 * (c + (dd < 0 ? -dd : dd))) {
                         if (v > best
                                 && xoff < x && x <= xlim - SNAKE_LIMIT
-                                && yoff < y && y <= ylim - SNAKE_LIMIT)
-                        {
+                                && yoff < y && y <= ylim - SNAKE_LIMIT) {
                             /* We have a good enough best diagonal.
                                now insist that it end with a significant snake.  */
@@ -310,6 +296,5 @@
 
                             for (k = 0; xvec[x + k] == yvec[y + k]; k++)
-                                if (k == SNAKE_LIMIT)
-                                {
+                                if (k == SNAKE_LIMIT) {
                                     best = v;
                                     bestpos = d;
@@ -319,6 +304,5 @@
                     }
                 }
-                if (best > 0)
-                {
+                if (best > 0) {
                     cost = 2 * c - 1;
                     return bestpos;
@@ -371,6 +355,5 @@
                    Let's verify that this is true.  */
                 throw new IllegalArgumentException("Empty subsequence");
-            else
-            {
+            else {
                 /* Use that point to split this problem into two subproblems.  */
                 compareseq (xoff, b, yoff, b - d);
@@ -425,6 +408,5 @@
         public  Change build_script(
                 final boolean[] changed0,int len0,
-                final boolean[] changed1,int len1)
-        {
+                final boolean[] changed1,int len1) {
             Change script = null;
             int i0 = 0, i1 = 0;
@@ -459,13 +441,10 @@
         public Change build_script(
                 final boolean[] changed0,int len0,
-                final boolean[] changed1,int len1)
-        {
+                final boolean[] changed1,int len1) {
             Change script = null;
             int i0 = len0, i1 = len1;
 
-            while (i0 >= 0 || i1 >= 0)
-            {
-                if (changed0[i0] || changed1[i1])
-                {
+            while (i0 >= 0 || i1 >= 0) {
+                if (changed0[i0] || changed1[i1]) {
                     int line0 = i0, line1 = i1;
 
@@ -670,6 +649,5 @@
             }
 
-            for (int i = 0; i < end; i++)
-            {
+            for (int i = 0; i < end; i++) {
                 int nmatch;
                 if (equivs[i] == 0) {
@@ -694,11 +672,9 @@
             final int end = bufferedLines;
 
-            for (int i = 0; i < end; i++)
-            {
+            for (int i = 0; i < end; i++) {
                 /* Cancel provisional discards not in middle of run of discards.  */
                 if (discards[i] == 2) {
                     discards[i] = 0;
-                } else if (discards[i] != 0)
-                {
+                } else if (discards[i] != 0) {
                     /* We have found a nonprovisional discard.  */
                     int j;
@@ -708,6 +684,5 @@
                     /* Find end of this run of discardable lines.
                        Count how many are provisionally discardable.  */
-                    for (j = i; j < end; j++)
-                    {
+                    for (j = i; j < end; j++) {
                         if (discards[j] == 0) {
                             break;
@@ -811,6 +786,5 @@
             int j = 0;
             for (int i = 0; i < end; ++i)
-                if (noDiscards || discards[i] == 0)
-                {
+                if (noDiscards || discards[i] == 0) {
                     undiscarded[j] = equivs[i];
                     realindexes[j++] = i;
@@ -853,5 +827,4 @@
       @param f the file being compared against
          */
-
         void shift_boundaries(FileData f) {
             final boolean[] changed = changedFlag;
@@ -863,6 +836,5 @@
             int other_preceding = -1;
 
-            for (;;)
-            {
+            for (;;) {
                 int start, end, other_start;
 
@@ -870,6 +842,5 @@
                    Also keep track of the corresponding point in the other file.  */
 
-                while (i < i_end && !changed[1+i])
-                {
+                while (i < i_end && !changed[1+i]) {
                     while (other_changed[1+j++]) {
                         /* Non-corresponding lines in the other file
@@ -887,6 +858,5 @@
                 other_start = j;
 
-                for (;;)
-                {
+                for (;;) {
                     /* Now find the end of this run of changes.  */
 
@@ -905,11 +875,6 @@
                        Only because the previous run was shifted here.  */
 
-                    if (end != i_end
-                            && equivs[start] == equivs[end]
-                                                       && !other_changed[1+j]
-                                                                         && !((preceding >= 0 && start == preceding)
-                                                                                 || (other_preceding >= 0
-                                                                                         && other_start == other_preceding)))
-                    {
+                    if (end != i_end && equivs[start] == equivs[end] && !other_changed[1+j]
+                         && !((preceding >= 0 && start == preceding) || (other_preceding >= 0 && other_start == other_preceding))) {
                         changed[1+end++] = true;
                         changed[1+start++] = false;
Index: trunk/src/org/openstreetmap/josm/tools/Geometry.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/Geometry.java	(revision 8394)
+++ trunk/src/org/openstreetmap/josm/tools/Geometry.java	(revision 8395)
@@ -601,6 +601,5 @@
             if ((newPoint.getEastNorth().getY() < point.getEastNorth().getY()) == (point.getEastNorth().getY() <= oldPoint.getEastNorth().getY())
                     && (point.getEastNorth().getX() - p1.getEastNorth().getX()) * (p2.getEastNorth().getY() - p1.getEastNorth().getY())
-                    < (p2.getEastNorth().getX() - p1.getEastNorth().getX()) * (point.getEastNorth().getY() - p1.getEastNorth().getY()))
-            {
+                    < (p2.getEastNorth().getX() - p1.getEastNorth().getX()) * (point.getEastNorth().getY() - p1.getEastNorth().getY())) {
                 inside = !inside;
             }
@@ -638,5 +637,5 @@
     }
 
-    protected static double calcX(Node p1){
+    protected static double calcX(Node p1) {
         double lat1, lon1, lat2, lon2;
         double dlon, dlat;
Index: trunk/src/org/openstreetmap/josm/tools/ImageProvider.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/ImageProvider.java	(revision 8394)
+++ trunk/src/org/openstreetmap/josm/tools/ImageProvider.java	(revision 8395)
@@ -935,6 +935,5 @@
                         return svg == null ? null : new ImageResource(svg);
                     case OTHER:
-                        while(size > 0)
-                        {
+                        while(size > 0) {
                             int l = is.read(buf, offs, size);
                             offs += l;
Index: trunk/src/org/openstreetmap/josm/tools/Shortcut.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/Shortcut.java	(revision 8394)
+++ trunk/src/org/openstreetmap/josm/tools/Shortcut.java	(revision 8395)
@@ -253,7 +253,6 @@
     public static List<Shortcut> listAll() {
         List<Shortcut> l = new ArrayList<>();
-        for(Shortcut c : shortcuts.values())
-        {
-            if(!"core:none".equals(c.shortText)) {
+        for (Shortcut c : shortcuts.values()) {
+            if (!"core:none".equals(c.shortText)) {
                 l.add(c);
             }