Index: trunk/src/org/openstreetmap/josm/tools/AlphanumComparator.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/AlphanumComparator.java	(revision 8416)
+++ trunk/src/org/openstreetmap/josm/tools/AlphanumComparator.java	(revision 8419)
@@ -40,5 +40,5 @@
  *
  */
-public class AlphanumComparator implements Comparator<String>, Serializable {
+public final class AlphanumComparator implements Comparator<String>, Serializable {
 
     private static final long serialVersionUID = 1L;
Index: trunk/src/org/openstreetmap/josm/tools/AudioPlayer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/AudioPlayer.java	(revision 8416)
+++ trunk/src/org/openstreetmap/josm/tools/AudioPlayer.java	(revision 8419)
@@ -79,10 +79,10 @@
                 throw new InterruptedException();
         }
-        protected void failed (Exception e) {
+        protected void failed(Exception e) {
             exception = e;
             result = Result.FAILED;
             state = State.NOTPLAYING;
         }
-        protected void ok (State newState) {
+        protected void ok(State newState) {
             result = Result.OK;
             state = newState;
Index: trunk/src/org/openstreetmap/josm/tools/ColorScale.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/ColorScale.java	(revision 8416)
+++ trunk/src/org/openstreetmap/josm/tools/ColorScale.java	(revision 8419)
@@ -10,5 +10,5 @@
  * @since 7319
  */
-public class ColorScale {
+public final class ColorScale {
     private double min, max;
     private Color noDataColor;
Index: trunk/src/org/openstreetmap/josm/tools/Diff.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/Diff.java	(revision 8416)
+++ trunk/src/org/openstreetmap/josm/tools/Diff.java	(revision 8419)
@@ -152,5 +152,5 @@
      It cannot cause incorrect diff output.  */
 
-    private int diag (int xoff, int xlim, int yoff, int ylim) {
+    private int diag(int xoff, int xlim, int yoff, int ylim) {
         final int[] fd = fdiag; // Give the compiler a chance.
         final int[] bd = bdiag; // Additional help for the compiler.
@@ -323,5 +323,5 @@
      All line numbers are origin-0 and discarded lines are not counted.  */
 
-    private void compareseq (int xoff, int xlim, int yoff, int ylim) {
+    private void compareseq(int xoff, int xlim, int yoff, int ylim) {
         /* Slide down the bottom initial diagonal. */
         while (xoff < xlim && yoff < ylim && xvec[xoff] == yvec[yoff]) {
@@ -345,5 +345,5 @@
             /* Find a point of correspondence in the middle of the files.  */
 
-            int d = diag (xoff, xlim, yoff, ylim);
+            int d = diag(xoff, xlim, yoff, ylim);
             int c = cost;
             int b = bdiag[bdiagoff + d];
@@ -357,10 +357,10 @@
             else {
                 /* Use that point to split this problem into two subproblems.  */
-                compareseq (xoff, b, yoff, b - d);
+                compareseq(xoff, b, yoff, b - d);
                 /* This used to use f instead of b,
                    but that is incorrect!
                    It is not necessarily the case that diagonal d
                    has a snake from b to f.  */
-                compareseq (b, xlim, b - d, ylim);
+                compareseq(b, xlim, b - d, ylim);
             }
         }
@@ -494,5 +494,5 @@
        and avoid even thinking about them in the main comparison algorithm.  */
 
-        discard_confusing_lines ();
+        discard_confusing_lines();
 
         /* Now do the main comparison algorithm, considering just the
@@ -509,5 +509,5 @@
         bdiagoff = filevec[1].nondiscardedLines + 1;
 
-        compareseq (0, filevec[0].nondiscardedLines,
+        compareseq(0, filevec[0].nondiscardedLines,
                 0, filevec[1].nondiscardedLines);
         fdiag = null;
@@ -517,5 +517,5 @@
        in cases where that can validly be done.  */
 
-        shift_boundaries ();
+        shift_boundaries();
 
         /* Get the results of comparison in the form of a chain
@@ -631,8 +631,7 @@
          * Mark to be discarded each line that matches no line of another file.
          * If a line matches many lines, mark it as provisionally discardable.
+         * @param counts The count of each equivalence number for the other file.
+         * @return 0=nondiscardable, 1=discardable or 2=provisionally discardable for each line
          * @see #equivCount()
-         * @param counts The count of each equivalence number for the other file.
-         * @return 0=nondiscardable, 1=discardable or 2=provisionally discardable
-         *  for each line
          */
         private byte[] discardable(final int[] counts) {
Index: trunk/src/org/openstreetmap/josm/tools/FontsManager.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/FontsManager.java	(revision 8416)
+++ trunk/src/org/openstreetmap/josm/tools/FontsManager.java	(revision 8419)
@@ -17,5 +17,5 @@
  * @since 7383
  */
-public class FontsManager {
+public final class FontsManager {
 
     /**
Index: trunk/src/org/openstreetmap/josm/tools/Geometry.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/Geometry.java	(revision 8416)
+++ trunk/src/org/openstreetmap/josm/tools/Geometry.java	(revision 8419)
@@ -424,6 +424,6 @@
      * @param point Point for which a closest point is searched on line (P1,P2)
      * @return The closest point found on line. It may be outside the segment [P1,P2].
+     * @see #closestPointToSegment
      * @since 4134
-     * @see #closestPointToSegment
      */
     public static EastNorth closestPointToLine(EastNorth lineP1, EastNorth lineP2, EastNorth point) {
@@ -690,8 +690,8 @@
     /**
      * Determines whether path from nodes list is oriented clockwise.
-     * @see #isClockwise(Way)
      * @param nodes Nodes list to be checked.
      * @return true if and only if way is oriented clockwise.
      * @throws IllegalArgumentException if way is not closed (see {@link Way#isClosed}).
+     * @see #isClockwise(Way)
      */
     public static boolean isClockwise(List<Node> nodes) {
Index: trunk/src/org/openstreetmap/josm/tools/ImageProvider.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/ImageProvider.java	(revision 8416)
+++ trunk/src/org/openstreetmap/josm/tools/ImageProvider.java	(revision 8419)
@@ -466,6 +466,6 @@
      * Limit the maximum width of the image.
      * @param maxWidth maximum image width
+     * @return the current object, for convenience
      * @see #setMaxSize
-     * @return the current object, for convenience
      */
     public ImageProvider setMaxWidth(int maxWidth) {
@@ -477,6 +477,6 @@
      * Limit the maximum height of the image.
      * @param maxHeight maximum image height
+     * @return the current object, for convenience
      * @see #setMaxSize
-     * @return the current object, for convenience
      */
     public ImageProvider setMaxHeight(int maxHeight) {
@@ -1102,5 +1102,5 @@
             parser.setEntityResolver(new EntityResolver() {
                 @Override
-                public InputSource resolveEntity (String publicId, String systemId) {
+                public InputSource resolveEntity(String publicId, String systemId) {
                     return new InputSource(new ByteArrayInputStream(new byte[0]));
                 }
@@ -1545,6 +1545,6 @@
      * @return the {@code TransparentColor} defined in image reader metadata, or {@code null}
      * @throws IOException if an error occurs during reading
+     * @see <a href="http://docs.oracle.com/javase/7/docs/api/javax/imageio/metadata/doc-files/standard_metadata.html">javax_imageio_1.0 metadata</a>
      * @since 7499
-     * @see <a href="http://docs.oracle.com/javase/7/docs/api/javax/imageio/metadata/doc-files/standard_metadata.html">javax_imageio_1.0 metadata</a>
      */
     public static Color getTransparentColor(ColorModel model, ImageReader reader) throws IOException {
Index: trunk/src/org/openstreetmap/josm/tools/LanguageInfo.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/LanguageInfo.java	(revision 8416)
+++ trunk/src/org/openstreetmap/josm/tools/LanguageInfo.java	(revision 8419)
@@ -225,6 +225,6 @@
      *
      * @param locale the locale to use, <code>null</code> for default locale
+     * @return list of codes
      * @since 8283
-     * @return list of codes
      */
     public static Collection<String> getLanguageCodes(Locale l) {
Index: trunk/src/org/openstreetmap/josm/tools/Shortcut.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/Shortcut.java	(revision 8416)
+++ trunk/src/org/openstreetmap/josm/tools/Shortcut.java	(revision 8419)
@@ -218,6 +218,6 @@
         if (keyStroke == null) return "";
         String modifText = KeyEvent.getKeyModifiersText(keyStroke.getModifiers());
-        if ("".equals (modifText)) return KeyEvent.getKeyText (keyStroke.getKeyCode ());
-        return modifText + "+" + KeyEvent.getKeyText(keyStroke.getKeyCode ());
+        if ("".equals (modifText)) return KeyEvent.getKeyText(keyStroke.getKeyCode());
+        return modifText + "+" + KeyEvent.getKeyText(keyStroke.getKeyCode());
     }
 
Index: trunk/src/org/openstreetmap/josm/tools/Utils.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/Utils.java	(revision 8416)
+++ trunk/src/org/openstreetmap/josm/tools/Utils.java	(revision 8419)
@@ -878,9 +878,9 @@
     /**
      * An alternative to {@link String#trim()} to effectively remove all leading and trailing white characters, including Unicode ones.
-     * @see <a href="http://closingbraces.net/2008/11/11/javastringtrim/">Java’s String.trim has a strange idea of whitespace</a>
-     * @see <a href="https://bugs.openjdk.java.net/browse/JDK-4080617">JDK bug 4080617</a>
      * @param str The string to strip
      * @return <code>str</code>, without leading and trailing characters, according to
      *         {@link Character#isWhitespace(char)} and {@link Character#isSpaceChar(char)}.
+     * @see <a href="http://closingbraces.net/2008/11/11/javastringtrim/">Java’s String.trim has a strange idea of whitespace</a>
+     * @see <a href="https://bugs.openjdk.java.net/browse/JDK-4080617">JDK bug 4080617</a>
      * @since 5772
      */
Index: trunk/src/org/openstreetmap/josm/tools/XmlObjectParser.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/XmlObjectParser.java	(revision 8416)
+++ trunk/src/org/openstreetmap/josm/tools/XmlObjectParser.java	(revision 8419)
@@ -54,5 +54,5 @@
 
         @Override
-        public void startElement (String uri, String localName, String qName, Attributes atts) throws SAXException {
+        public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException {
             if ("".equals(uri)) {
                 super.startElement(namespace, localName, qName, atts);